﻿Type=Class
Version=2.71
@EndOfDesignText@
' =======================================================================================
' Title .........: fgen (FormGen)
' Description ...: Form Generator
' Requirement(s).: Basic4Android 2.70
' Author ........: Giovanni Rossati (El Condor)
' Version........: 0.3.0
' Date...........: 1 July 2013
' =======================================================================================
'Class module
Sub Class_Globals
	Dim fh_Data As Map		' Reference to widget of data
	Dim fh_yesToExit As Boolean = True	' used for block exit 
	Private fh_activity As Activity
	Private fh_returnSub() As String	' Module and sub
	Private fh_handleSub() As String	' Module and sub for handle events
	Private fh_panel As ScrollView	' Reference to panel handle
	Dim widgetRef As Map	' Reference to widget of data
	Dim mapPanels As Map	' Reference to panel handle
	Private Elem As Map		' data fields
	Private tipsMap As Map	' tooltips Map key is field name
	Dim nElem As Int		' Elements number	
	Dim Limits As Map 		' for numerics fields
	Dim mapValues As Map	' combo/radio key value
	Dim field() As String
	Dim wWidget As Int		' maximum widget width
	Dim VR As VoiceRecognition
	VR.Initialize("VR")
	Private focusedText As EditText
End Sub
'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
End Sub
Sub fg(act As Activity,params As String,retSub As String,handleSub As String)
	fh_activity = act
	fh_returnSub = Regex.Split("\.",retSub)		' split module and sub
	fh_handleSub = Regex.Split("\.",handleSub)	' split module and sub
	Dim pnl As Panel
	Dim lbl As Label
	Dim btn As Button
	Dim cmb As Spinner
	Dim rdb As RadioButton
Dim widgets() As String
Dim dummy,width, btnWidth,offsetX, offsetBtn, offsetY, offsetLabelY,x,deltaY As Int
Dim charWidth As Int = 12
Dim finalButtons = "Cancel:Cancel:Cancel,",wdgType As String
Dim fromTo() As String	' array for limits
Dim typeForm As String	' typeForm: T = text, B = buttons
offsetX = 5%x
offsetY = 40dip
offsetLabelY = 11%y
width = 50dip
btnWidth = 65dip
deltaY = 36dip
Elem.Initialize
mapValues.Initialize
tipsMap.Initialize
widgetRef.Initialize
mapPanels.Initialize
Limits.Initialize
widgets = Regex.Split(";", params)
fh_panel.Initialize(750)
Dim c As Canvas
c.Initialize(act)
Dim dimLabels As Int = 0
' normalize request: control and clean parameters
For i = 0 To widgets.Length - 1
	field = Regex.Split(",", widgets(i) & ",,,,,,*")
	If field(1) = "" Then field(1) = field(0)	' if there is not label
	field(1) = deMask(field(1))
	If field(2) = "" Then field(2) = Max(20,field(4).Length)
	field(3) = field(3).ToUpperCase	' upper case
	If field(3) = "" Then field(3) = "T"
	Select field(3)
		Case "CKBM","BM","BCM"	' if unnecessary mandatory
			field(3) = Left(field(3),field(3).Length-1)
		Case "S","SM"
			If field(5) = "" Then field(5) = "0 100"	' default slide
			fromTo = Regex.split(" ",field(5))
			Limits.Put(field(0) & "Min",fromTo(0))
			Limits.Put(field(0) & "Max", 100)
			If fromTo.Length = 2 Then Limits.Put(field(0) & "Max",fromTo(1))
			If field(4) = "" Then field(4) = (Limits.get(field(0) & "Max") + Limits.get(field(0) & "Min")) / 2	' default value
	End Select
	field(4) = deMask(field(4))
	field(5) = deMask(field(5))
	dummy = c.MeasureStringWidth(field(1),Typeface.DEFAULT,12)
	If dummy > dimLabels Then dimLabels = dummy
	If field(3) = "TITLE" Then		' title
		lbl.Initialize("")
		lbl.TextSize = 20
		lbl.Typeface = Typeface.DEFAULT_BOLD
		lbl.text = iIF(field(4)="",field(1), field(4))
		x = c.MeasureStringWidth(lbl.text,Typeface.DEFAULT,20) * 1.1
		fh_panel.Panel.AddView(lbl,(100%x - x)/2 , 9dip , x, 30dip)
		widgetRef.Put(field(0),Array As Object (lbl,"TITLE"))
	Else If field(3) = "TIP" Then		' tool tip
		tipsMap.Put(field(5),field(4))
	Else
		Elem.Put(field(0),field)
	End If
Next
nElem = Elem.Size
' compute maximum widget width
wWidget = (100%x -2 * offsetX -5dip -dimLabels) / charWidth
Dim btns() As String
Dim Buttons(32) As Button	' event handler
typeForm = ""
' create form -------------------------------------------------------------------------------------
For i = 0 To nElem - 1
	pnl.Initialize("")
	lbl.Initialize("")
	field = Elem.GetValueAt(i)
	lbl.TextSize = 12
	lbl.text = field(1)
	wdgType = field(3)
	If Right(wdgType,1) = "M" Then wdgType = Left(wdgType,wdgType.Length-1)
	If wdgType <> "B" AND wdgType <> "BC" Then pnl.AddView(lbl,offsetX, 5dip, width*2, width)
	Dim txtProto As EditText
	If wdgType = "B" OR  wdgType = "BC" Then
		If wdgType = "B" Then typeForm = typeForm & "B"
		finalButtons = finalButtons & field(1) & ":" & field(0) & ","
		widgetRef.Put(field(0),Array As Object (0,wdgType,0,field(5)))	' completed after
	Else If wdgType = "CKB" Then
		Dim ckbProto As CheckBox
		ckbProto.Initialize("checkBox")
		ckbProto.TextSize = 12
		ckbProto.text = " " & field(5)
		ckbProto.Tag = field(0)
		pnl.AddView(ckbProto ,offsetX+5dip + dimLabels , 0 , field(2) * charWidth, deltaY-2dip)
		widgetRef.Put(field(0),Array As Object (ckbProto,wdgType,lbl))
	Else If wdgType = "R" Then			' *** Radiobuttons
		Dim rdbList As List,j As Int
		rdbList = splitKeyValue(field(0),field(5))
		widgetRef.Put(field(0),Array As Object (0,wdgType,lbl,0))
		For j = 0 To rdbList.Size-1
			rdb.Initialize("RadioButton")
			rdb.TextSize = 12
			rdb.text = rdbList.get(j)
			rdb.Tag = field(0)
			pnl.AddView(rdb,offsetX+5dip + dimLabels + j*field(2) * charWidth , 0 , field(2) * charWidth, deltaY-2dip)
			If rdbList.get(j) = field(4) Then widgetRef.Put(field(0),Array As Object (rdb,wdgType,lbl,rdb))	' default
		Next
	Else If wdgType = "CMB" OR wdgType = "F" Then		' *** ComboBox (spinner) and File
		cmb.Initialize("combos") 'All combos share the same event sub
		cmb.TextSize = 12
		pnl.AddView(cmb,offsetX+5dip + dimLabels , 0 , field(2) * charWidth, deltaY-2dip)
		cmb.Tag = field(0)
		If wdgType <> "F" Then
			cmb.addall(splitKeyValue(field(0),field(5)))
		End If
		widgetRef.Put(field(0),Array As Object (cmb,wdgType,lbl,""))
	Else If wdgType = "U" Then 
		Dim uLbl As Label
		uLbl.Initialize("")
		uLbl.text = field(4)
		widgetRef.Put(field(0),Array As Object (uLbl,wdgType,lbl,uLbl))
		pnl.AddView(uLbl,offsetX+5dip + dimLabels, 0, iIF(field(2) > wWidget, wWidget,field(2)) * charWidth, getHeight(Ceil(field(2)/wWidget)))		
	Else
		txtProto.Initialize("txt")
		txtProto.Gravity = Bit.OR(Gravity.TOP, Gravity.Left)
		If wdgType = "P" Then txtProto.PasswordMode = True
		If wdgType = "DN" OR wdgType = "S" OR wdgType = "N" Then	' numerics fields
			txtProto.Gravity = Gravity.Right
			txtProto.InputType = txtProto.INPUT_TYPE_DECIMAL_NUMBERS
			If wdgType = "N" Then txtProto.InputType = txtProto.INPUT_TYPE_NUMBERS
		End If
		txtProto.TextSize = 12
		txtProto.Tag = field(0)
		txtProto.ForceDoneButton = True
		pnl.AddView(txtProto,offsetX+5dip + dimLabels , 0 , iIF(field(2) > wWidget, wWidget,field(2)) * charWidth, getHeight(Ceil(field(2)/wWidget)))
		widgetRef.Put(field(0),Array As Object (txtProto,wdgType,lbl,txtProto))
		If wdgType = "S" Then	' *** slide ***
			txtProto.Enabled = False
			Dim sldProto As SeekBar
			sldProto.Initialize("Slide")
			sldProto.Tag = field(0)	' widget name
			widgetRef.Put(field(0),Array As Object (sldProto,wdgType,lbl,txtProto))
			pnl.AddView(sldProto,offsetX+8dip + dimLabels + field(2) * charWidth , 0 , width*3, deltaY*0.9)
		Else If wdgType = "CMT" Then		' *** ComboBox (spinner) with text
			cmb.Initialize("combos") 		'All combos share the same event sub
			cmb.TextSize = 12
			cmb.addall(splitKeyValue(field(0),field(5)))
			pnl.AddView(cmb,offsetX+5dip + dimLabels , deltaY , field(2) * charWidth, deltaY-2dip)
			cmb.Tag = field(0)
			widgetRef.Put(field(0),Array As Object (txtProto,wdgType,lbl,cmb))
		Else
			txtProto.HintColor = Colors.LightGray
			txtProto.Hint = field(5)
		End If
	End If
	If wdgType <> "B"  AND  wdgType <> "BC" Then
		Dim pnlHeight As Int = getHeight(Ceil(field(2)/wWidget))
		If wdgType = "CMT" Then pnlHeight = 2*deltaY
		fh_panel.Panel.AddView(pnl,0,offsetY,100%x,pnlHeight)
		mapPanels.put(field(0),pnl)
		typeForm = typeForm & "T"
		offsetY = offsetY + pnlHeight
		offsetLabelY  = offsetLabelY  + pnlHeight
	End If
Next
' what buttons?
If typeForm.IndexOf("T") > -1 Then finalButtons = finalButtons & "Reset:Reset,"
If typeForm.IndexOf("B") = -1 Then finalButtons = finalButtons & "Ok:Ok,"
btns = Regex.Split(",",Left(finalButtons,finalButtons.Length-1))
offsetBtn = offsetX +(100%x - offsetX*2 - btns.Length*(btnWidth)) * 0.5
For i = 0 To btns.Length - 1
	Dim btn As Button
	btn.Initialize("buttons")
	btn.TextSize = 12
	Dim k() As String
	k = Regex.Split(":",btns(i))
	btn.text = k(0)
	btn.Tag = k(1)
	fh_panel.Panel.AddView(btn,offsetBtn +i*btnWidth,offsetY+6dip,btnWidth+10dip, deltaY-1dip)
	mapPanels.put(btn.tag,btn)
	If btn.Tag = "Ok" Then widgetRef.Put(k(1),Array As Object (btn,"B",lbl))	' lbl is fictious
	If btn.Tag <> "Ok" AND  btn.Tag <> "Cancel" AND  btn.Tag <> "Reset" Then
		widgetRef.Put(k(1),Array As Object (btn,takeFromMap(btn.Tag,1),lbl,takeFromMap(btn.Tag,3)))	' completed widgetRef key 
	End If
	Buttons(i) = btn
Next
fh_Data.Initialize
setDefaults
act.AddView(fh_panel,0,0,100%x,90%y)
fh_panel.Panel.Height = offsetY+deltaY+5dip
handleEvents(Array As Object ("fh_start","Start"))
End Sub
Private Sub setDefaults()
	For i=0 To nElem -1
		field = Elem.GetValueAt(i)
		setValue(field(0),field(4))
	Next
End Sub
Private Sub getHeight(rows As Int) As Int
Return 18dip+rows*18dip	' font size 12 height = 18
End Sub
Private Sub deMask(data As String) As String
	Dim s As String 
	s = data.Replace(Chr(1),",")
	Return s.Replace(Chr(2),";")
End Sub
Sub mask(data As String) As String	' mask comma AND semicolon
	Dim s As String
	s = data.Replace(",",Chr(1))
	Return s.Replace(";",Chr(2))
End Sub
Sub Left(s As String,l As Int) As String
If l < s.Length Then Return s.SubString2(0,l)
Return s
End Sub
Sub Right(s As String,l As Int) As String
If l < s.Length Then Return s.SubString(s.Length-l)
Return s
End Sub
Sub iIF(Cond As Boolean,First As Object,Second As Object) As Object
	If Cond Then Return First
	Return Second
End Sub
Private Sub insertlistDir(dir As String) As List
	Dim lst As List
	lst.Initialize
	Try 
		lst.AddAll(File.ListFiles(dir))
	Catch
	End Try 
	lst.SortCaseInsensitive(True)
	If dir.indexOf2("/",1) > -1 Then lst.InsertAt(0,"..")
	Return lst
End Sub
Private Sub splitKeyValue(name As String,data As String) As List	' split key value (combos AND option buttons) ***********************
  Dim lst As List
  Dim dt(),key,value As String,k As Int 
  dt = Regex.Split("\|", data)
	lst.Initialize
	For j = 0 To dt.Length - 1
		If dt(j).IndexOf(":") < 0 Then dt(j)=dt(j) & ":" & dt(j)
		k = dt(j).IndexOf(":")
		key = dt(j).SubString2(0,k)
		value = dt(j).SubString(k+1)
		mapValues.Put(name & value,key)
		lst.add(value)
	Next
	Return lst
End Sub
Private Sub Buttons_Click		' *** exit routin
	Dim btn As Button = Sender
	handleEvents(Array As Object (btn.tag,"CLICK",btn))
	fh_Data.Clear
	If btn.Tag = "Reset" Then 
		setDefaults
		handleEvents(Array As Object ("fh_reset","Reset"))
	Else If btn.Tag = "Cancel" Then
		fh_Data.Put("fh_button",btn.Tag)
		fh_activity.RemoveAllViews
		CallSubDelayed2(fh_returnSub(0),fh_returnSub(1),fh_Data)
	Else		
		If takeFromMap(btn.Tag,1) = "BC" Then
			Dim	fh_CallBackSub() As String = Regex.Split("\.",takeFromMap(btn.Tag,3))		' split module and sub
			If fh_CallBackSub.Length = 2 Then CallSubDelayed2(fh_CallBackSub(0),fh_CallBackSub(1),btn.Tag)
			Return
		End If
		If Not(CheckErrors(btn,btn.Tag)) Then
			If fh_yesToExit Then
				handleEvents(Array As Object ("fh_end","End"))
				fh_activity.RemoveAllViews
				CallSubDelayed2(fh_returnSub(0),fh_returnSub(1),fh_Data)
			End If
		End If
	End If
End Sub
Private Sub CheckErrors(btnx As Object,widgetTag As String)	As Boolean	' for button end spinner aka button list
	Dim mustContinue As Boolean = False
	Dim wdgtValue As String
	Dim wdgl As Label
	For i = 0 To nElem -1
		field = Elem.GetValueAt(i)
		If Right(field(3),1) = "M" Then 
			wdgtValue = valueOf(field(0))
			wdgl = takeFromMap(field(0),2)
			wdgl.TextColor = Colors.White
			If wdgtValue = "" Then
				mustContinue = True
				wdgl.TextColor = Colors.Red
			End If
		End If
	Next
	If Not(mustContinue) Then
		fh_Data.Put("fh_button",widgetTag)
		For i=0 To nElem -1		' take data 
			field = Elem.GetvalueAt(i)
			fh_Data.Put(field(0),valueOf(field(0)))
		Next
	End If
	Return mustContinue
End Sub
Private Sub handleEvents(parms() As Object) As Boolean
	If fh_handleSub.Length = 2 Then 
		CallSub2(fh_handleSub(0),fh_handleSub(1),parms)
	End If
End Sub
Private Sub Combos_ItemClick(Position As Int, Value As Object)
	Dim cb As Spinner = Sender
	Dim typeWidget As String = GetWType(cb.Tag)
	handleEvents(Array As Object (cb.Tag,"CLICK",cb,Value))
	If typeWidget = "F" Then
		Dim dir As String = takeFromMap(cb.Tag,3)
		If cb.SelectedItem = ".." Then
			cb.Clear
			setInMap(cb.Tag,3,stripSubDir(dir))
			cb.AddAll(insertlistDir(takeFromMap(cb.Tag,3)))
		Else
			If File.IsDirectory(dir, Value) = True Then
				cb.Clear
				cb.AddAll(insertlistDir(dir & "/" & Value))
				setInMap(cb.Tag,3,dir  & "/" & Value)
				cb.SelectedIndex = 0
			End If
		End If
		cb.Prompt = takeFromMap(cb.Tag,3)
	Else If typeWidget = "CMT" Then 
		setValue(cb.Tag,Value)
	End If
End Sub
Private Sub RadioButton_CheckedChange(chk As Boolean)
	Dim rdb As RadioButton= Sender
	Dim a() As Object = widgetRef.get(rdb.Tag)
	a(0) = Sender
	widgetRef.Put(rdb.tag,a)
	handleEvents(Array As Object (rdb.tag,"CLICK",Sender,mapValues.get(rdb.Tag & rdb.text)))
End Sub
Private Sub txt_EnterPressed
	'txt = Sender
	'fh_module.handleEvents(Sender,Array As Object (txt.tag,"ENTER"))
End Sub
Sub txt_FocusChanged (HasFocus As Boolean)
	focusedText = Sender
	handleEvents(Array As Object (focusedText.tag,iIF(HasFocus,"FOCUS","LFOCUS"),Sender,focusedText.text))
	If HasFocus Then
		If GetWType(focusedText.Tag) = "T" Then startVoiceRec
		If tipsMap.ContainsKey(focusedText.Tag) Then ToastMessageShow(tipsMap.get(focusedText.Tag),True)
	End If
End Sub
Private Sub checkBox_CheckedChange(Checked As Boolean)
	Dim ckb As CheckBox = Sender
	handleEvents(Array As Object (ckb.tag,"CHK",Sender,iIF(Checked,1,0)))
End Sub
Private Sub Slide_ValueChanged (Value As Int, UserChanged As Boolean)
	Dim slideValue As Double,dec As Int,txtSlider As EditText
	Dim sld As SeekBar = Sender
	txtSlider = takeFromMap(sld.Tag,3)
	slideValue = Limits.get(sld.Tag & "Min") + Value * (Limits.get(sld.Tag & "Max") - Limits.get(sld.Tag & "Min"))/100
	handleEvents(Array As Object (sld.Tag,"SLIDE",sld,slideValue,takeFromMap(sld.tag,3)))
	dec = Floor(Logarithm(Abs(Limits.get(sld.Tag & "Min")-Limits.get(sld.Tag & "Max")),10))	' delta
	txtSlider.text = NumberFormat(slideValue,1,0)
	If dec < 3 Then txtSlider.text = NumberFormat(slideValue,1,-dec+2)
End Sub
Sub toText(msk As String, values() As Object) As String
	Dim k,j=0 As Int
	Dim str As String
	Dim mtc As Matcher
	Dim strMatch As String = "%\d{0,2}\.\d|%\d{0,2}"	' accept % %n %nn %nn.n
	Dim editFormat() As String
	mtc = Regex.Matcher(strMatch,msk)
	Do While mtc.Find = True
    	k = msk.IndexOf(mtc.Match)
		'If k < 0 Then Exit
		If j < values.Length Then
			editFormat = Regex.Split("\.","0" & mtc.Match.SubString(1) & ".0.0")
			Select TypeOf(values(j))
				Case "Integer","Double"
					str = NumberFormat2(values(j),0,editFormat(1),editFormat(1),True)
					If editFormat(0) > 0 Then str = Right(fillString(editFormat(0)) & str,editFormat(0)) 
				Case Else
					str = values(j)
					If editFormat(0) > 0 Then str = Left(values(j) & fillString(editFormat(0)),editFormat(0))
			End Select
			msk = Left(msk,k) & str & msk.SubString(k+mtc.Match.Length)
		End If
		j = j+1
	Loop
	Return msk
End Sub
Sub TypeOf(obj As Object) As String
Dim t() As String = Regex.Split("\.",GetType(obj))
Return t(2)
End Sub
Private Sub fillString(n) As String
	Dim i As Int
	Dim str As String = ""
	For i=0 To n Step 10
		str = str & "          "
	Next
	Return Left(str,n)
End Sub
Private Sub setSpinner(spin As Spinner,parms() As String)
	spin.SelectedIndex = iIF(spin.IndexOf(parms(1)) > - 1,spin.IndexOf(parms(1)),0)
End Sub
Private Sub setInMap(fld As String,pos As Int,val As Object)	' From field widget map parameters field, position
	Dim aWdg() As Object
	If Not(widgetRef.ContainsKey(fld)) Then Return 
	aWdg = widgetRef.get(fld)
	If pos < aWdg.Length Then 
		aWdg(pos) = val
		widgetRef.Put(fld,aWdg)
	End If
End Sub
Sub stripSubDir(dir As String) As String
	Dim k As Int
	For k = dir.Length -1 To 0 Step -1
		If dir.CharAt(k) = "/" Then Exit
	Next
	If k > -1 Then Return dir.SubString2(0,k) 
	Return ""
End Sub
Sub stripFile(dir As String) As String
	Dim k As Int
	For k = dir.Length -1 To 0 Step -1
		If dir.CharAt(k) = "/" Then Exit
	Next
	If k > -1 Then Return dir.SubString(k+1)
	Return dir
End Sub
Sub startVoiceRec()
	VR.Listen 'calls the voice recognition external activity
End Sub
Sub VR_Result (Success As Boolean, Texts As List)
	If Success = True Then
		Dim a() As Object = Array As Object(focusedText.tag,"VREND",focusedText,Texts.get(0))
		handleEvents(a)
		focusedText.text = iIF(focusedText.text = "",  a(3), focusedText.text & Chr(13) & Chr(10) &  a(3))
		startVoiceRec
	End If
End Sub
Sub enable(Name)
	SetWidget(Name,"Enable")
End Sub
Sub disable(Name)
	SetWidget(Name,"Disable")
End Sub
Sub SetWidget(Name As String,option As String) As Object
	If Not(mapPanels.ContainsKey(Name)) Then Return	' key exist?
	Dim v As View = mapPanels.get(Name)
	Dim opt As String = option.ToLowerCase
	Select opt
		Case "enable","disable"
			If TypeOf(v) = "Button"  Then 
				v.Enabled = iIF(opt = "enable",True,False)
			Else
				Dim p As Panel = mapPanels.get(Name)
				For i = 0 To p.NumberOfViews -1
					p.GetView(i).Enabled = iIF(opt = "enable",True,False)
				Next
			End If
		Case "visible","hidden"
			v.Visible = iIF(opt = "hidden",False,True)
	End Select
End Sub
Sub getHandle(Name As String) As Object
	Dim a() As Object = Array As Object(0)
	If widgetRef.ContainsKey(Name) Then a = widgetRef.get(Name)
	Return a(0)
End Sub
Private Sub takeFromMap(fld As String,pos As Int) As Object	' From field widget map parameters field, position
	Dim aWdg() As Object
	If Not(widgetRef.ContainsKey(fld)) Then Return 0 
	aWdg = widgetRef.get(fld)
	If pos < aWdg.Length Then Return aWdg(pos)
	Return 0
End Sub
Sub GetWType(Name As String) As String
	Dim a() As Object = Array As Object(0)
	If widgetRef.ContainsKey(Name) Then
		a = widgetRef.get(Name)
		Return a(1)	' type
	End If
	Return ""
End Sub
Sub valueOf(Name As String) As String
	Dim a() As Object
	If widgetRef.ContainsKey(Name) Then
		a = widgetRef.get(Name)
		Select a(1)		' widget type
			Case "CMB","F"
				Dim cmb As Spinner = a(0)
				If a(1) = "CMB" Then Return mapValues.get(Name & cmb.SelectedItem)
				Return a(3) & "/" & iIF(cmb.SelectedItem = "..","",cmb.SelectedItem)
			Case "CKB"
				Dim chk As CheckBox = a(0)
				Return (iIF(chk.Checked,"1","0"))
			Case "S"		' SeekBar
				Dim txt As EditText = a(3)
				Return txt.text
			Case "U"		' Unmodifiable
				Dim uLbl As Label = a(0)
				Return uLbl.text
			Case "R"		' RadioButton
				If a(0) = 0 Then Return ""
				Dim rdb As RadioButton = a(0)
				Return mapValues.get(Name & rdb.text)
			Case "B","BC"
				Return Name
			Case Else 		' text Views also CMT combo text
				Dim wdgT As EditText = a(0)
				Return wdgT.text
		End Select	
	End If
	Return ""
End Sub
Sub implode(sep As String,obj() As Object) As String
	Dim i As Int
	Dim implStr As StringBuilder
	implStr.Initialize 
	For i = 0 To obj.Length - 1
	     implStr.Append(sep & obj(i))
	Next
	Return implStr.ToString.SubString(sep.length)
End Sub
Sub setValue(Name As String,Value As String)
	Dim wdg As Object = iIF(widgetRef.ContainsKey(Name),takeFromMap(Name,0),-1)
	If wdg = -1 Then Return	' no field
	Select GetWType(Name)
		Case "CMB"
			Dim cmb As Spinner = wdg
			setSpinner(cmb,Array As String(Name,Value))
		Case "CMT"
			Dim cmb As Spinner = takeFromMap(Name,3)
			Dim t As EditText = wdg
			t.Text = Value
			setSpinner(cmb,Array As String(Name,Value))
		Case "F"
			Dim cmb As Spinner = wdg
			Dim dir As String = Value
			Dim fl As String = ""
			If Not(File.isDirectory("",Value)) Then
				dir = stripSubDir(Value)
				fl = stripFile(Value)
			End If
			If dir = "" Then dir = File.DirRootExternal
			cmb.Clear
			cmb.addall(insertlistDir(dir))
			cmb.Prompt = dir
			setInMap(Name,3,dir)
			cmb.SelectedIndex = cmb.IndexOf(fl)
		Case "S"
			Dim sld As SeekBar = wdg
			sld.Value = (Value - Limits.get(sld.Tag & "Min"))*100/(Limits.get(sld.Tag & "Max") - Limits.get(sld.Tag & "Min"))
		Case "T","N","DN","P"
			Dim txt As EditText = wdg
			txt.text = Value
		Case "CKB"
			Dim chk As CheckBox = wdg
			chk.Checked = iIF(Left(Value,5).ToLowerCase = "check" OR Value = "1", True,False)
		Case "U" 
			Dim uLbl As Label = wdg
			uLbl.text = Value
		Case "R"
			Dim p As Panel = mapPanels.get(Name)
			setInMap(Name,0,0)
			For i = 0 To p.NumberOfViews -1
				If GetType(p.GetView(i)).Contains("RadioButton") Then
					Dim rdb As RadioButton = p.GetView(i)
					rdb.Checked = False
					If rdb.text = Value Then 
						rdb.Checked = True
						setInMap(Name,0,rdb)
					End If
				End If
			Next
		Case "B","BC"
			Dim btn As Button = wdg
			btn.Enabled = iIF(Left(Value,3).ToLowerCase = "dis",False,True)
	End Select
End Sub